(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: VALCOREZ.PAS                                                   *)
(*  Obsah: rozvinovac sikmo seriznutych valcu                              *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 20.5.2010                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program Cirkularka;
label PredcasnyKonec; {na odskok pri pripadnem zadani podelne nebo kolmo riznuteho valce}
const MaxBodu=10000; {absolutni maximum je zhruba 10921, ale stejne se to v praxi nevyuzije}
var prumer,vyska,zesikmeni:real; {rozmery pozadovaneho valce (zada uzivatel)}
    PocetBodu:word; {na kolik bodu se hledana krivka rozdeli (zada uzivatel)}
    obvod:real; {obvod valce (vypocita se)}
    y:array[0..10000] of real; {pro ulozeni yovych souradnic bodu krivky (vypocitaji se)}
    x:word; {pracovni souradnice (pomocna promenna pro vypocet)}
    vystup:text; {textovy soubor pro export vysledku...}
    JmenoVystupu:string[79]; {...a jeho jmeno}
    odpoved:string[1]; {pro prikazy od uzivatele}
    sirka:byte; {na jakou sirku se maji zarovnavat vysledky}
BEGIN
writeln('*      *     *    *   *  * Valcorez *  *   *    *     *      *');
writeln('Program na sikme rezani kulatiny a jeji rozbalovani do plochy');
writeln('-------------------------------------------------------------');
writeln('Hledame rozvinuty plast sikmo seriznuteho valce, cili tohohle:');
writeln('   ____________');
writeln('  |\          ^<--------zesikmeni');
writeln('  |  \|_______|______');
writeln('  |   .\      |     ^                 (prehlednejsi obrazek');
writeln('  |   |  \ ___v     |                 je v souboru SCHEMA.GIF)');
writeln('  |   .   |         |<--vyska');
writeln('  |   |   |         |');
writeln('  |___.___|_________v');
writeln('  |   |   |');
writeln('  |       |');
writeln('  | prumer|');
writeln('  |<----->|');
 repeat
 writeln;
 write('Zadej prumer valce:    '); readln(prumer);
 write('Zadej vysku valce:     '); readln(vyska);
 write('Chces zadat zesikmeni vyskou, nebo uhlem? (V/U) '); readln(odpoved);
 if upcase(odpoved[1])='U' then begin
                                write('Zadej uhel zesikmeni (ve stupnich): ');
                                 repeat
                                 readln(zesikmeni); {docasne - pak se prevede na vysku}
                                 if zesikmeni=90
                                   then begin
                                        writeln('Na podelny rez nepotrebujes pocitac - rozvinuty plast bude siroky pul');
                                        write('obvodu, tedy ',pi*prumer/2:0:2,' delkovych jednotek. Staci? (A/N) ');
                                        readln(odpoved);
                                        if upcase(odpoved[1])='A' then goto PredcasnyKonec
                                                                  else write('Tak zadej jiny uhel: ');
                                        end;
                                 until zesikmeni<>90;
                                zesikmeni:=zesikmeni*pi/180; {prevod na radiany}
                                zesikmeni:=prumer*sin(zesikmeni)/cos(zesikmeni); {prevod na vysku}
                                end
                           else begin
                                write('Zadej vysku zesikmeni: ');
                                readln(zesikmeni);
                                end;
 if abs(zesikmeni)<0.0001 then begin {prakticky nulove zesikmeni}
                               writeln('Na kolmo riznuty valec nepotrebujes pocitac - rozvinuty plast bude obdelnik');
                               writeln('o sirce rovne obvodu valce: ',pi*prumer:0:2,' delkovych jednotek.');
                               goto PredcasnyKonec;
                               end;
 writeln;
 writeln('Sikma podstava je elipsa o velkem prumeru ',sqrt(sqr(prumer)+sqr(zesikmeni)):0:2,' delkovych jednotek.');
 obvod:=pi*prumer;
 writeln('Obvod plaste vychazi ',obvod:0:2,' delkovych jednotek.');
 write('Na kolik dilku chces obvod rozdelit? (max. ',maxbodu,'): '); readln(pocetbodu);
 if pocetbodu>maxbodu then pocetbodu:=maxbodu
  else if pocetbodu<2 then pocetbodu:=2;

 write('Pocitam body... ');
 for x:=0 to pocetbodu-1 do y[x]:=vyska+(zesikmeni/2)*sin(2*pi*x/(pocetbodu-1)-pi/2);
 writeln('...hotovo.');
 {Co tim chtel basnik rici:
  Mame sinusovku y=A*sin(omega*t+fi), kde omega je uhlova frekvence, fi je
 faze, A amplituda a t uhel, ktery se protoci od 0 do 2*pi (tj. 360 stupnu).
  Vime, ze omega=2*pi/T, kde T je perioda. Perioda je v nasem pripade delkova
 velicina a jeji hodnota je rovna obvodu valce.
  Fazi zvolime -pi/2, aby spoj valce vysel do mista, kde bude nejkratsi.
  Jako vstupni promennou mame index x, ktery bude nabyvat hodnot od 0 do
 pocetbodu-1 a ktery potrebujeme prepocitat na t. Predpokladejme, ze chceme
 mit prvni bod na jednom kraji rozvinuteho valce, posledni na druhem kraji
 (tj. ve stejne vysce jako ten prvni, protoze se pak ve finale slepi a nesmi
 tam byt schod) a ostatni rovnomerne rozlozene mezi nimi, aby delily obvod na
 pocetbodu-1 useku o delce obvod/(pocetbodu-1). Vynasobenim bezrozmerneho
 indexu x delkou jednoho useku ziskame hodnotu t v jednotkach delky, coz
 presne chceme.
  Amplituda je absolutni hodnota nejvetsiho vykyvu sinusovky od nulove
 hodnoty, v nasem pripade je rovna polovine vysky zesikmeni.

  Dosadime:
 y(t) =      A       * sin(    omega     *            t            + fi )
 y[x]:=(zesikmeni/2) * sin( (2*pi/obvod) * (x*obvod/(pocetbodu-1)) -pi/2)

  Po pricteni vysky (protoze souradnice bodu nechceme merit od nuly, ale od
 spodniho okraje valce) a uprave rovnice (obvod se nam vykrati) ziskame
 vyse uvedeny vyraz.}

 writeln('Zadej jmeno souboru, do ktereho se maji ulozit vysledky');
 write('(nic = vypis na obrazovku): '); readln(jmenovystupu);
 assign(vystup,jmenovystupu); {kdyby bylo prazdne, pujde to na obrazovku}
 {$I-}
 if jmenovystupu<>''
   then begin
        reset(vystup);
        close(vystup);
        if ioresult=0 then begin
                           write('Soubor ',jmenovystupu,' uz existuje, ma se prepsat? (A/N) ');
                           readln(odpoved);
                           if upcase(odpoved[1])<>'A' then begin
                                                           jmenovystupu:='';
                                                           assign(vystup,''); {presmerovani souboru na obrazovku}
                                                           end;
                           end;
        end;
 if jmenovystupu<>'' then begin
                          rewrite(vystup);
                          if ioresult<>0 then begin
                                              writeln('Chyba pri otvirani souboru pro zapis, vystup pujde na obrazovku.');
                                              jmenovystupu:='';
                                              assign(vystup,'');
                                              end;
                          end;
 {$I+}
 if jmenovystupu='' then begin
                         append(vystup);
                         sirka:=9; {at to na obrazovce vypada hezky}
                         end
                    else sirka:=0; {at v souboru nejsou zbytecne mezery}
 {vystupni zarizeni je pripraveno, muzeme ukladat:}
 writeln(vystup,'x':sirka,#9,'y':sirka);
 for x:=0 to pocetbodu-1 do
  begin
  writeln(vystup,x*obvod/(pocetbodu-1):sirka:2,#9,y[x]:sirka:2);
  {#9 je tabulator, aby se vysledky daly otevrit a zpracovat v Excelu}
  if (x mod 20=0)and(x>0)and(x<pocetbodu-1)and(jmenovystupu='')
    then begin {nutna pauza, aby nam vysledky neujely mimo obrazovku}
         write('Pro dalsich 20 radku zmackni Enter, pro ukonceni zadej X:');
         readln(odpoved);
         if upcase(odpoved[1])='X' then break;
         end;
  end;
 if jmenovystupu<>'' then begin
                          writeln(vystup,'obvod':sirka,#9,obvod:sirka:2);
                          writeln(vystup,'sikma podstava:':sirka,#9,prumer:sirka:2,#9'x'#9,
                                         sqrt(sqr(prumer)+sqr(zesikmeni)):sirka:2);
                          close(vystup);
                          end;
 writeln;
 writeln('                  * * *');
 writeln;
 write('Vypis vysledku dokoncen. Dalsi vypocet? (A/N) '); readln(odpoved);
 until upcase(odpoved[1])<>'A';
writeln;
writeln('Preji vesele rysovani...');
writeln;
writeln(' ^            _._');
writeln(' |         _-~   ~-_');
writeln(' |y  __..-~         ~-..__');
writeln(' |  |                     |');
writeln(' |  |                     |');
writeln('_|__|_____________________|');
writeln('    |    x');
writeln('    |---------->');
PredcasnyKonec:
writeln;
write('Stiskni Enter pro ukonceni programu.'); readln;
writeln;
writeln;
writeln('(cc) Mircosoft 2010    (http://mircosoft.mzf.cz)');
END.